#! /bin/sh

#############################################################################
# Configure
Home=`pwd`
ZenLib_Options=" --without-subdirs --enable-gui"

#############################################################################
# ZLib (should be in MediaInfoLib later)
if test -e Shared/Source/ZLib/libz.a; then
 echo ZLib is already compiled
else
 if test -e Shared/Project/ZLib/Compile.sh; then
  cd Shared/Project/ZLib
  chmod u+x Compile.sh
  ./Compile.sh
  cd $Home
  if test -e Shared/Source/ZLib/libz.a; then
   echo ZLib compiled
  else
   echo Problem while compiling ZLib
   exit
  fi
  else
   echo Shared directory is not found
   exit
 fi
fi

#############################################################################
# ZenLib
if test -e ZenLib/Project/GNU/Library/configure; then
 cd ZenLib/Project/GNU/Library/
 test -e Makefile && rm Makefile
 chmod u+x configure
 ./configure $ZenLib_Options $*
 if test -e Makefile; then
  make clean
  make
  if test -e libZenLib.la; then
   echo ZenLib compiled
  else
   echo Problem while compiling ZenLib
   exit
  fi
 else
  echo Problem while configuring ZenLib
  exit
 fi
else
 echo ZenLib directory is not found
 exit
fi
cd $Home

#############################################################################
# MediaInfoLib
if test -e MediaInfoLib/Project/GNU/Library/configure; then
 cd MediaInfoLib/Project/GNU/Library/
 test -e Makefile && rm Makefile
 chmod u+x configure
 ./configure $*
 if test -e Makefile; then
  make clean
  make
  if test -e libMediaInfoLib.la; then
   echo MediaInfoLib compiled
  else
   echo Problem while compiling MediaInfoLib
   exit
  fi
 else
  echo Problem while configuring MediaInfoLib
  exit
 fi
else
 echo MediaInfoLib directory is not found
 exit
fi
cd $Home

#############################################################################
# MediaInfo
if test -e MediaInfo/Project/GNU/GUI/configure; then
 cd MediaInfo/Project/GNU/GUI/
 test -e Makefile && rm Makefile
 chmod u+x configure
 ./configure $*
 if test -e Makefile; then
  make clean
  make
  if test -e MediaInfo; then
   echo MediaInfo compiled
  else
   echo Problem while compiling MediaInfo
   exit
  fi
 else
  echo Problem while configuring MediaInfo
  exit
 fi
else
 echo MediaInfo directory is not found
 exit
fi
cd $Home

#############################################################################
# Going home
cd $Home
echo "MediaInfo executable is in MediaInfo/Project/GNU/GUI"