// File_Mpegts_Pms - Info for MPEG Transport Stream files
// Copyright (C) 2006-2007 Jerome Martinez, Zen@MediaArea.net
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// Information about MPEG Transport Stream files, Program Map Section
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//---------------------------------------------------------------------------
#ifndef MediaInfo_MpegTs_PmsH
#define MediaInfo_MpegTs_PmsH
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include "MediaInfo/File__Base.h"
//---------------------------------------------------------------------------

namespace MediaInfoLib
{

//***************************************************************************
// Class File_MpegTs_Pms
//***************************************************************************

class File_MpegTs_Pms : public File__Base
{
protected :
    //Formats
    void Read_Buffer_Init ();
    void Read_Buffer_Continue ();

private :
    bool Buffer_Parse();
    bool Element_Parse();
    size_t Element_Size;

    //Elements
    void Header();
    void Footer();
    void Element();
    void Descriptors();
    void Descriptor();
    void Descriptor_00() {};
    void Descriptor_01() {};
    void Descriptor_02() {};
    void Descriptor_03() {};
    void Descriptor_04() {};
    void Descriptor_05() {};
    void Descriptor_06() {};
    void Descriptor_07() {};
    void Descriptor_08() {};
    void Descriptor_09() {};
    void Descriptor_0A();
    void Descriptor_0B() {};
    void Descriptor_0C() {};
    void Descriptor_0D() {};
    void Descriptor_0E();
    void Descriptor_0F();
    void Descriptor_10() {};
    void Descriptor_11() {};
    void Descriptor_12() {};
    void Descriptor_13() {};
    void Descriptor_14() {};
    void Descriptor_15() {};
    void Descriptor_16() {};
    void Descriptor_17() {};
    void Descriptor_18() {};
    void Descriptor_19() {};
    void Descriptor_1A() {};
    void Descriptor_1B() {};
    void Descriptor_1C() {};
    void Descriptor_1D() {};
    void Descriptor_1E() {};
    void Descriptor_1F() {};
    void Descriptor_20() {};
    void Descriptor_21() {};
    void Descriptor_22() {};
    void Descriptor_23() {};

    //Temp
    int32u section_length;
    int32u stream_info_length;
};

} //NameSpace

#endif
