// File_VorbisCom - Info for VorbisComments tagged files
// Copyright (C) 2007-2007 Jerome Martinez, Zen@MediaArea.net
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// Information about Vorbis comments
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//---------------------------------------------------------------------------
#ifndef MediaInfo_File_VorbisComH
#define MediaInfo_File_VorbisComH
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include "MediaInfo/File__Base.h"
//---------------------------------------------------------------------------

namespace MediaInfoLib
{

//***************************************************************************
// Class File_VorbisCom
//***************************************************************************

class File_VorbisCom : public File__Base
{
public :
    stream_t StreamKind;
    size_t Comment_Size;

protected :
    //Format
    void Read_Buffer_Init ();
    void Read_Buffer_Continue ();

private :
    //Buffer
    bool Buffer_Parse();
    bool Element_Parse();
    size_t Element_Size;
    int32u Element_Name;
    int64u Element_Next;

    //Elements
    void Header();
    void Comment();

    //Temp
    int32u vendor_length;
    int32u user_comment_list_length;
    int32u user_comment_length;
    Ztring Chapter_Pos;
    Ztring Chapter_Time;
    
protected :
    //Information
    void HowTo (stream_t StreamKind);
};

//***************************************************************************
// Class File_VorbisCom_Helper
//***************************************************************************

class File_VorbisCom_Helper
{
public :
    File_VorbisCom_Helper(File__Base* Base_);
    ~File_VorbisCom_Helper();

protected :
    //Temp
    File_VorbisCom* VorbisCom;

    //From elsewhere
    bool VorbisCom_Read_Buffer_Continue ();
    void VorbisCom_Read_Buffer_Finalize ();

    //Data
    File__Base* Base;
};

} //NameSpace

#endif
